<?
/*
	XTP (XORE TRACKER PHP) 2006
	WRITTEN FOR HIGHSPEED SERVERS THAT ARE CAPABLE EACCELERATOR
	
	CONFIG GUIDELINES (RECOMENDED)
	-----------------------------------------------------------------------------------------------------
	
	RECOMENDED SERVER HARDWARE SPECS:
	LINUX (ANY DISTRO WITHOUT GUI'S)
	AT LEAST 1GB RAM
	AT LEAST P4 3.0 GHZ / OR SIMILAIR XEON ETC..
	
	RECOMENDED SERVER SOFTWARE SPECS:
	PHP4 => FASTER THEN PHP5
	PHP FASTCGI
	LIGHTTPD WITH FASTCGI SUPPORT
	EACCELERATOR (CONFIGURE TO GET THE MOST OUT OF IT)
	
	SERVER CONFIG TIPS:
	TURN OF LOGGING FOR: PHP, EACCELERATOR,LIGHTTPD
	OPTIMIZE YOUR SYSCTL.CONF
*/


// Turn off error reporting
error_reporting(0);

// Cache announce data for 2 minutes (120 seconds) -- Ignored if not supported or uncomment to dissable function call
//@eaccelerator_cache_page($_SERVER['PHP_SELF'].'?GET='.serialize($_GET), 120);

$hash = $_GET['info_hash'];

// Check if hash has a length of 20 chars
if (isset($hash{20})) 
{
$hash = stripcslashes($hash);
}

if (isset($hash{20})) 
{
die('d14:failure reason' . strlen('Invalid hash') . ':' . 'Invalid hash' . 'e');
}

$timestamp = intval((time() % 7680) / 60);

// Remaining size for download
if($_GET['left'] == 0)
{
$timestamp += 128;
}
$timestamp = pack("C", $timestamp);


// Some stuff put into a var since we will need these later (elimination of regeneration overhead)
$hash = bin2hex($hash);
$ip = explode('.', $_SERVER['REMOTE_ADDR']);
$ip = pack("C*", $ip[0], $ip[1], $ip[2], $ip[3]);
$port = pack("n*", (int)$_GET['port']);

// Check if announce/scrape file exists, if not create one (using touch instead of fopen/fclose)
if(!file_exists($hash))
{
touch($hash);
}

// Open file for writing/reading/modification (we have used containers because we need them more then 1 time)
$open_file = fopen($hash, "rb+");
flock($open_file, LOCK_EX);
$peer_count = intval(filesize($hash) / 7);
$input_data = fread($open_file, $peer_count * 7);
$peer = array();
$updated = false;

// Using while instead of for (saves us lots of memory/time
$i=0;
while($i<$peer_count){
$i++;


if($ip . $port == substr($input_data, $i * 7 + 1, 6)){

$updated = true;

if($_GET['event'] == 'stopped'){
$peer_count--;
}

else{
$peer[$i] = $timestamp . $ip . $port;
}
}


else{
$peer[$i] = substr($input_data, $i * 7, 7);
}
}


// Check
if($updated == false){
$peer[] = $timestamp . $ip . $port;
$peer_count++;
}

// Add/modify file
rewind($open_file);
ftruncate($open_file, 0);
fwrite($open_file, join('', $peer), $peer_count * 7);
flock($open_file, LOCK_UN);
fclose($open_file);


if($_GET['event'] == 'stopped' || $_GET['numwant'] === 0){
$x .= '';
}

else{

if($peer_count > 50){
$key = array_rand ($peer, 50);

foreach($key as $val){
$x .= substr($peer[$val], 1, 6);
}
}
else{
$y=0;
while($y<$peer_count)
{
$y++;
$x .= substr($peer[$i], 1, 6);
}
}
}

// Return reannounce time wait
die('d8:intervali1800e5:peers' . strlen($x) . ':' . $x . 'e');

?>